'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _router = require('./router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
  var endpoints;
  return _regenerator2.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          endpoints = _config2.default._routeMap;


          _fsExtra2.default.ensureDirSync('.lightrail');
          _fsExtra2.default.outputJsonSync('.lightrail/endpoints.json', endpoints);

          (0, _router.createRoute)({
            method: 'GET',
            url: _config2.default.documentationUrl,
            handler: function handler(req, res) {
              var _this = this;

              return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
                var contents;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return new Promise(function (resolve, reject) {
                          _fsExtra2.default.readJson('.lightrail/endpoints.json', 'utf8', function (err, data) {
                            if (err) reject(err);else resolve(data);
                          });
                        });

                      case 2:
                        contents = _context.sent;
                        return _context.abrupt('return', contents);

                      case 4:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }))();
            }
          });

        case 4:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, this);
}));